#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
#-------------------------------------------------------------------------
#    Name:  dbamon_metrics.pl
#-------------------------------------------------------------------------
#
# Changes 
#
# 1.00 21Dec10 BB - Initial
# 1.10 31Jan11 BB - Added VERB argument - Now Mode, VERB, Instance, In_Categ, In_Parm 
# 1.11 16Nov11 BB - Added HTTPS capability 
# 1.12 08Feb12 BB - Changed MAXROWS from 200 to 50 
#-------------------------------------------------------------------------
$version = "1.12"; 
$| = 1;
chop($P = `basename $0`); 
$P =~ s/\.pl$//g;

push(@INC,"/opt/dbamon/lib");

require "cgi_handlers.pl";
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

$maxrows = 250;

$days    = 180;
$debug   = 1;
$stop_displaying = 0;

#---- Max these vars global
$in_categ = $categ_desc = $parm_desc = "";  

#---- PL and CSV Vars and FILES - Start - Should only happen 1 time
mkdir "/opt/dbamon/dat/dyn" if (! -e "/opt/dbamon/dat/dyn"); 
system("ln -s /opt/dbamon/dat/dyn /opt/dbamon/htm/dyn") if ! -e "/opt/dbamon/htm/dyn"; 

#---- Old
#chop($pl_date = `date +%Y%m%d_%H%M%S`);
#$zdiag .= "old pl_date=($pl_date)\n"; 

#---- New
$pl_date = getdate(); 
$pl_date =~ s/\///g;
$pl_date =~ s/\://g;
$pl_date =~ s/\-/_/;
##$zdiag .= "new pl_date=($pl_date)\n"; 

$pl_v1_file        = "/opt/dbamon/dat/dyn/${P}_v1_${pl_date}_${$}.txt"; 
$csv_v1_file_short = "${P}_v1_${pl_date}_${$}.csv"; 
$csv_v1_file       = "/opt/dbamon/dat/dyn/$csv_v1_file_short"; 

$pl_avg_file        = "/opt/dbamon/dat/dyn/${P}_avg_${pl_date}_${$}.txt"; 
$csv_avg_file_short = "${P}_avg_${pl_date}_${$}.csv"; 
$csv_avg_file       = "/opt/dbamon/dat/dyn/$csv_avg_file_short"; 

$pl_min_file        = "/opt/dbamon/dat/dyn/${P}_min_${pl_date}_${$}.txt"; 
$csv_min_file_short = "${P}_min_${pl_date}_${$}.csv"; 
$csv_min_file       = "/opt/dbamon/dat/dyn/$csv_min_file_short"; 

$pl_sum_file        = "/opt/dbamon/dat/dyn/${P}_sum_${pl_date}_${$}.txt"; 
$csv_sum_file_short = "${P}_sum_${pl_date}_${$}.csv"; 
$csv_sum_file       = "/opt/dbamon/dat/dyn/$csv_sum_file_short"; 

$pl_max_file        = "/opt/dbamon/dat/dyn/${P}_max_${pl_date}_${$}.txt"; 
$csv_max_file_short = "${P}_max_${pl_date}_${$}.csv"; 
$csv_max_file       = "/opt/dbamon/dat/dyn/$csv_max_file_short"; 

$pl_val_file        = "/opt/dbamon/dat/dyn/${P}_val_${pl_date}_${$}.txt"; 
$csv_val_file_short = "${P}_val_${pl_date}_${$}.csv"; 
$csv_val_file       = "/opt/dbamon/dat/dyn/$csv_val_file_short"; 
#---- PL and CSV Vars and FILES - End

#---- Read WWW_Font:

#---- Old
#chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
#if ($font =~ /%/)
#{
#  $font =~ s/%/ /g;
#  $font = "'$font'";
#}
#$zdiag .= "old font=($font)\n"; 

#---- New
$font                 = &readRC("WWW_Font:");
$table_metrics_hourly = &readRC("Table_METRICS_HOURLY:");
$table_detail_retain  = &readRC("Table_Detail_Retain_Days:");
$table_detail_retain  = 30 if ! $table_detail_retain; 

##$zdiag .= "new font=($font)\n"; 

$font = "arial" if ! $font;

#---- Set connect string and hostname for URLs
if ($ENV{'HTTPS'} eq "on") { $http_prefix = "https://"; } 
else                       { $http_prefix = "http://"; } 
$http_host = $http_prefix . $ENV{'HTTP_HOST'};

$script_name = $ENV{'SCRIPT_NAME'};

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

use DBI;
require "cgi_handlers.pl";

#---- Old
# $database = "dbamon";
# 
## See if DBAmon is configured to use Oracle
#chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
#chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
#chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
#if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
#{
#  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
#  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
#  ##$user = "dbamon";
#  ##chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
#  ##$data_source = "DBI:Oracle";
#  $database = $ORACLE_SID;
#  $dbms = "oracle";
#}

#-----------------------------------------------------------------------------
sub menuInstance
#-----------------------------------------------------------------------------
{
  print "
  <h3>
  Metrics Reporting Menu for Instance: $instance
  </h3>
  <span style='$style_normal'> 
  <table border=0 bgcolor=wheat $style_normal>
  <tr bgcolor=slateblue>
    <th><span $style_normal>Metric<br> Type 
    <th><span $style_normal>Raw or<br> Summarized <br>Data 
    <th><span $style_normal>Metric<br> Description
    <th><span $style_normal>Data<br> Span 
  "; 

  #$bg = &bgRow; 
  #print "<tr $bg> <td> <b><a href='http://$http_host/${script_name}?$mode,GHOURLY,$instance'>TEST - Hourly Graph </a></b> 
  #  <td>Summarized
  #  <td>Summarized Max per Hour 
  #  <td>Historical
  #"; 

  #print "<tr bgcolor=slateblue><td colspan=6> <br> <b>Current Readings: <p> \n"; 

  $bg = &bgRow; 
  print "<tr $bg> <td> <b><a href='$http_host/${script_name}?$mode,MCURRENT,$instance'>Current Readings</a></b>
    <td>Raw
    <td>The Most Current Metrics Readings for This Instance 
    <td>Current
  "; 

  #print "<tr bgcolor=slateblue><td colspan=6> <br> <b>Unsummarized Raw Data: <p> \n"; 

  $bg = &bgRow; 
  print "<tr $bg> <td> <b><a href='$http_host/${script_name}?$mode,MDETAIL,$instance'>Detailed Data</a></b>
    <td>Raw
    <td>All Observations for All Metrics (Not Summarized)
    <td>Last $table_detail_retain Days 
  "; 

  #print "<tr bgcolor=slateblue><td colspan=6> <br> <b>Summarized Data: <p> \n"; 

  if ($table_metrics_hourly eq "Y") 
  {
    $bg = &bgRow; 
    print "<tr $bg> <td> <b><a href='$http_host/${script_name}?$mode,MHOURLY,$instance'>Historical Data - Hourly</a></b> 
      <td>Summarized
      <td>Summarized (Min/Max/Avg/Sum) per Hour 
      <td>Historical
    "; 
  }

  $bg = &bgRow; 
  print "<tr $bg> <td> <b><a href='$http_host/${script_name}?$mode,MDAILY,$instance'>Historical Data - Daily </a></b>  
    <td>Summarized
    <td>Summarized (Min/Max/Avg/Sum) per Day 
    <td>Historical
  "; 

  #---- Obsolete 
  #$bg = &bgRow; 
  #print "<tr $bg> <td> <b><a href='$http_host/${script_name}?$mode,HISTORY,$instance'>Historical Metrics Data </a></b> 
  #  <td>Raw
  #  <td>The First Reading Per Day (Obsolete)
  #  <td>Historical
  #"; 

  print "</table><p>\n"; 
  &msg("menuInstance - Done");  
}

#-----------------------------------------------------------------------------
sub menuMain
#-----------------------------------------------------------------------------
{
  &msg("menuMain - Starting"); 
  $s_time = time;

  #      [dbamonmode]
  #     ,[instance]
  #     ,[system]
  #     ,[dbms]
  #     ,[category]
  #     ,[parm]
  #     ,[value]
  #     ,[value2]
  #     ,[value3]
  #     ,[value4]
  #     ,[ts]
  #     ,[zdate]

  # Create the SQL SELECT statement
  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	instance, 
        count(*),
        min(ts),
        max(ts)
      from 
	dbamon.history 
      where 
        dbamonmode = '$mode'
	and ts >= dateadd(dd,-$days,getdate())
      group by
	instance
      order by 1, 2
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }

  ##&msg("DEBUG - sql=$sql") if $debug; 
  &msg("Querying DBAMON.HISTORY data for instance_key=($instance) for the last six months - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds");

  print "<p>
  <h3>DBAmon Metrics / Parms Available for DBAmonMode=$mode InstanceKey=($instance) </h3>
  <table border=0 bgcolor=wheat $style_normal>
  
  \n";
  print "<tr bgcolor=slateblue>
    <th><span $style_normal>DB Instance 
    <th><span $style_normal>History Data<br>Min<br> Date 
    <th><span $style_normal>History Data<br>Max<br> Date 
    <th><span $style_normal>History Data<br> Row<br> Count 
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $instance = shift(@Data);  
    $count  = shift(@Data);  
    $mindate  = shift(@Data);  
    $maxdate  = shift(@Data);  

    #if ($parm eq "." || ! $parm)
    #{
    #  $where = "category = QQ${categ}QQ"; 
    #}
    #else
    #{
    #  $where = "category = QQ${categ}QQ and parm = QQ${parm}QQ "; 
    #}

    $bg = &bgRow;

    print "<tr $bg>
      <td $style_normal> <b><a href='$http_host/${script_name}?$mode,MENU,$instance'>$instance </a></b>
      <td $style_normal>  $mindate  
      <td $style_normal>  $maxdate  
      <td $style_normal align=right>  $count 
    " if ! $stop_displaying; 

    if (++$selectcount > $maxrows && ! $stop_displaying) 
    { 
      print "<tr bgcolor=pink><td colspan=15><b><font size=2>MaxRows threshold of $maxrows exceeded - Rows will be processed for files, but no more will be displayed\n";
      print "</table>\n";
      $stop_displaying = 1; 
    }
  }

  print "</table>\n";

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for mode=$mode\n";
  }

  print "</table><p>\n";
  &msg("menuMain - Done - Rows Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub selectHISTORYDataInstance
#-----------------------------------------------------------------------------
{
  &msg("selectHISTORYDataInstance - Starting"); 
  $s_time = time;

  #      [dbamonmode]
  #     ,[instance]
  #     ,[system]
  #     ,[dbms]
  #     ,[category]
  #     ,[parm]
  #     ,[value]
  #     ,[value2]
  #     ,[value3]
  #     ,[value4]
  #     ,[ts]
  #     ,[zdate]

  # Create the SQL SELECT statement
  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	category, 
	parm,
        count(*),
        min(ts),
        max(ts)
      from 
	dbamon.history 
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
	and ts >= dateadd(dd,-$days,getdate())
      group by
	category, 
	parm
      order by 1, 2
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }
  &msg("Running sql=$sql") if $debug; 

  &msg("Querying DBAMON.HISTORY data for instance_key=($instance) and mode=$mode for the last $days days");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds");

  print "<p>
  <h3>DBAmon Metrics / Parms Available for DBAmonMode=$mode InstanceKey=($instance) </h3>
  <table border=0 bgcolor=wheat $style_normal>
  
  \n";
  print "
  <tr bgcolor=slateblue>
    <th><span $style_normal>Metric / Metric Parm 
    <th><span $style_normal>Min<br> Date 
    <th><span $style_normal>Max<br> Date 
    <th><span $style_normal>Row<br> Count 
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $categ = shift(@Data);  
    $parm  = shift(@Data);  
    $count  = shift(@Data);  
    $mindate  = shift(@Data);  
    $maxdate  = shift(@Data);  

    #if ($parm eq "." || ! $parm)
    #{
    #  $where = "category = QQ${categ}QQ"; 
    #}
    #else
    #{
    #  $where = "category = QQ${categ}QQ and parm = QQ${parm}QQ "; 
    #}

    $bg = &bgRow;

    print "<tr $bg>
      <td $style_normal> <b> <a href='$http_host/${script_name}?$mode,HISTORY,$instance,$categ,$parm'>$categ / $parm</a>  </b>
      <td $style_normal>  $mindate  
      <td $style_normal>  $maxdate  
      <td $style_normal align=right>  $count 
    " if ! $stop_displaying; 

    if (++$selectcount > $maxrows && ! $stop_displaying) 
    { 
      print "<tr bgcolor=pink><td colspan=15><b><font size=2>MaxRows threshold of $maxrows exceeded - Rows will be processed for files, but no more will be displayed\n";
      print "</table>\n";
      $stop_displaying = 1; 
    }
  }

  print "</table>\n";

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }

  print "</table>\n";
  &msg("Rows Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub select_METRICS_Instance
#-----------------------------------------------------------------------------
{
  &msg("select_METRICS_Instance - Starting - m_table=$m_table - in_parm=$in_parm"); 
  $s_time = time;
  $maxrows = 999999;

  if ($in_parm ne "") 
  {
    $where = "and category like '%${in_parm}%'"; 
    $mhead = "$in_parm Metrics"; 
  }
  else
  {
    $where = ""; 
    $mhead = "All Metrics"; 
  }

  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	category, 
	parm,
        count(*),
        min(ts),
        max(ts),
        $min_max
      from 
	dbamon.$m_table 
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
	and ts >= dateadd(dd,-$days,getdate())
        $where
      group by
	category, 
	parm
      order by 1, 2
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }
  &msg("Querying DBAMON.$m_table for instance_key=($instance) and mode=$mode for the last $days days - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds");

  print "<p>
  <h3>DBAmon '$m_title' Data Reporting Available for DBAmonMode=$mode InstanceKey=($instance) Table=($m_table) - $mhead </h3>
  <table border=0 bgcolor=wheat $style_normal>
  
  \n";
  print "
  <tr bgcolor=slateblue>
    <th><span $style_normal>Metric / Metric Parm 
    <th colspan=2><span $style_normal>Available<br>Reports
    <th colspan=5><span $style_small> Detail Data Observations
  <tr bgcolor=slateblue>
    <th colspan=3>
    <th><span $style_small>Min/Max<br> Date 
    <th><span $style_small>Min/Max<br> Values 
    <th><span $style_small>Row<br> Cnt. 
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $categ   = shift(@Data);  
    $parm    = shift(@Data);  
    $count   = shift(@Data);  
    $mindate = shift(@Data);  
    $maxdate = shift(@Data);  
    $minval  = shift(@Data);  
    $maxval  = shift(@Data);  

    #if ($parm eq "." || ! $parm)
    #{
    #  $where = "category = QQ${categ}QQ"; 
    #}
    #else
    #{
    #  $where = "category = QQ${categ}QQ and parm = QQ${parm}QQ "; 
    #}

    
    my @zcwords = split(/\_/,$categ);
    my $zcateg_short = $zcwords[0] . "_" . $zcwords[1]; 

    if ($zcateg_short ne $categ_last) 
    {
      my $zdesc = ""; 
      if    ($zcateg_short eq "BCKAGE_D")    { $zdesc = "MSSQL Backup Age (Hours) - DB Backups"; }
      elsif ($zcateg_short eq "BCKAGE_L")    { $zdesc = "MSSQL Backup Age (Hours) - TLOG Backups"; }
      elsif ($zcateg_short eq "BCKAGE_FULL") { $zdesc = "MSSQL Full DB Backup Age (Days)"; }
      elsif ($zcateg_short eq "PERF_SQL")    { $zdesc = "Performance Metrics - MSSQL"; }
      elsif ($zcateg_short eq "PERF_SYS")    { $zdesc = "Performance Metrics - Windows Server"; }
      elsif ($zcateg_short eq "DRIVE_PCT")   { $zdesc = "Server Disk Drive Percent Full"; }

      print "<tr bgcolor=linen> <td $style_normal colspan=8> <br> &nbsp; Metrics Category: $zcateg_short - $zdesc <br> &nbsp; \n"; 
    }    
    $categ_last = $zcateg_short;

    $bg = &bgRow;

    print "<tr $bg>
      <td $style_normal> <b> $categ / $parm </b>
      <td $style_normal nowrap> <b> &nbsp; <a href='$http_host/${script_name}?$mode,$verb,$instance,$categ,$parm'>(1) Detail - All Obs. (L30D)</a>  </b> 
                         <b> &nbsp; <a href='$http_host/${script_name}?$mode,GRAW,$instance,$categ,$parm,30,'>Chart L30D</a>  </b> 
                         <b> &nbsp; <a href='$http_host/${script_name}?$mode,GRAW,$instance,$categ,$parm,10,'>Chart L10D</a>  </b> 
                         <b> &nbsp; <a href='$http_host/${script_name}?$mode,GRAW,$instance,$categ,$parm,7,'>Chart L7D</a>  </b> 
                         <b> &nbsp; <a href='$http_host/${script_name}?$mode,GRAW,$instance,$categ,$parm,3,'>Chart L3D</a>  </b> 
                         <b> &nbsp; <a href='$http_host/${script_name}?$mode,GRAW,$instance,$categ,$parm,2,'>Chart L2D</a>  </b> 
                         <b> &nbsp; <a href='$http_host/${script_name}?$mode,GRAW,$instance,$categ,$parm,1,'>Chart L1D</a>  </b> 
    &nbsp;
      <td $style_normal nowrap> <b> &nbsp; <a href='$http_host/${script_name}?$mode,MDAILY,$instance,$categ,$parm'>(2) Historical - Summarized Daily</a>  </b> 
    &nbsp;
      <td $style_micro nowrap>  $mindate /<br> $maxdate
      <td $style_micro nowrap>  $minval  /<br> $maxval
      <td $style_micro align=right nowrap>  $count 
    " if ! $stop_displaying; 

    if (++$selectcount > $maxrows && ! $stop_displaying) 
    { 
      print "<tr bgcolor=pink><td colspan=15><b><font size=2>MaxRows threshold of $maxrows exceeded - Rows will be processed for files, but no more will be displayed\n";
      print "</table>\n";
      $stop_displaying = 1; 
    }
  }

  print "</table>\n";

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }

  print "</table>\n";
  &msg("select_METRICS_Instance - Done - Rows Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub categExpand
#-----------------------------------------------------------------------------
{
  if    ($in_categ eq "SPC")            { $categ_desc = "DB Space Utilization";     $parm_desc = "DBName";  } 
  elsif ($in_categ eq "SPC_DB_USED")    { $categ_desc = "DB Space Util. - Used MB"; $parm_desc = "DBName";  } 
  elsif ($in_categ eq "SERVER_MEM")     { $categ_desc = "Server RAM Utilization";   $parm_desc = "";     } 
  elsif ($in_categ eq "SERVER_MEM_PCT") { $categ_desc = "Server RAM Precent Util.";   $parm_desc = "";     } 
  elsif ($in_categ eq "TLOG_RATIO")     { $categ_desc = "TLog/DBSize Ratio";        $parm_desc = "DBName";  } 
  elsif ($in_categ eq "DRIVE_SPACE" ||  
         $in_categ eq "DRIVE_PCT_FULL") { $categ_desc = "Drive Percent Full ";      $parm_desc = "Drive Letter";  } 
  else    { } 

  #---- If this value was not found above... 
  $categ_desc = $in_categ if ! $categ_desc;
}

#-----------------------------------------------------------------------------
sub select_METRICS_Values
#-----------------------------------------------------------------------------
{
  &msg("select_METRICS_Values - Starting - in_categ=$in_categ in_parm=$in_parm"); 
  $s_time = time;

  &categExpand;

  #      order by ts desc
  #        -- and ts >= dateadd(dd,-183,getdate())

  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	dbamon.dateconvert_19(ts), 
	system, 
	instance, 
        dbms,
	category, 
	parm,
	avg, min, max, sum
      from 
	dbamon.$m_table 
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
        and category = '$in_categ'
        and parm = '$in_parm'
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }

  &msg("  Querying DBAMON.$m_tble data for this instance - sql=$sql");
  ##&msg("WHERE Clause: instance = '$instance' $where2 $where3");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  $cell_width = 60;

  if ($in_parm eq ".") 
  {
    $out_instance_db = "$instance"; 
  }
  else
  {
    $out_instance_db = "$instance $parm_desc: $in_parm"; 
  }

  &msg("  Query elapsed time: $elapsed seconds - Writing results to file(s)...");


  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $ts    = shift(@Data); 
    $sy    = shift(@Data);  
    $in    = shift(@Data);  
    $dbms  = shift(@Data);  
    $categ = shift(@Data);  
    $parm  = shift(@Data);  
    $avg   = shift(@Data);  
    $min   = shift(@Data);  
    $max   = shift(@Data);  
    $sum   = shift(@Data);  

    #$bg = &bgRow;
    $bg = "bgcolor=white"; 

    if ($categ_desc ne $categ) { $zcat = "($categ_desc)" } 
    else                       { $zcat = "" } 

    #---- Data for ploticus
    $pl_ts  = substr($ts,0,10) . "." . substr($ts,11,5); 

    $www_vals{$pl_ts} = sprintf "<tr $bg>
      <td nowrap $style_normal> &nbsp; $ts &nbsp; 
      <td nowrap $style_normal> &nbsp; $in &nbsp;
      <td nowrap $style_normal> &nbsp; <b> $categ $zcat </b> &nbsp;
      <td nowrap $style_normal> &nbsp; <b> $parm </b> &nbsp;
      <td nowrap $style_normal align=right zidth=$cell_width> &nbsp; <b> $avg </b> &nbsp;
      <td nowrap $style_normal align=right zidth=$cell_width> &nbsp; <b> $min </b> &nbsp;
      <td nowrap $style_normal align=right zidth=$cell_width> &nbsp; <b> $max </b> &nbsp;
      <td nowrap $style_normal align=right zidth=$cell_width> &nbsp; <b> $sum </b> &nbsp;
    ";

    $pl_avg_vals{$pl_ts} = $avg; 
    $pl_min_vals{$pl_ts} = $min; 
    $pl_max_vals{$pl_ts} = $max; 
    $pl_sum_vals{$pl_ts} = $sum; 
  }

  if ($selectcount == 0) 
  { 
    &msg("No event history data found for instance: $instance");
  }

  &msg("Rows Selected: $selectcount");

  #---- Write ploticus data
  if ($pl_ts)
  {
    #---- avg File
    #&msg("Writing plot data to $pl_avg_file"); 
    open(PL,">$pl_avg_file") || &error("Cannot open output $pl_avg_file - $!"); 
    $pl_cnt = 0;
    foreach $this_key (sort keys %pl_avg_vals)
    {
      print PL "$this_key $pl_avg_vals{$this_key}\n"; 
      $pl_cnt++; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_avg_file") if $debug_wrote; 

    #---- min File
    #&msg("Writing plot data to $pl_min_file"); 
    open(PL,">$pl_min_file") || &error("Cannot open output $pl_min_file - $!"); 
    $pl_cnt = 0;
    foreach $this_key (sort keys %pl_min_vals)
    {
      print PL "$this_key $pl_min_vals{$this_key}\n"; 
      $pl_cnt++; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_min_file") if $debug_wrote; 

    #---- max File
    #&msg("Writing plot data to $pl_max_file"); 
    open(PL,">$pl_max_file") || &error("Cannot open output $pl_max_file - $!"); 
    $pl_cnt = 0;
    foreach $this_key (sort keys %pl_max_vals)
    {
      print PL "$this_key $pl_max_vals{$this_key}\n"; 
      $pl_cnt++; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_max_file") if $debug_wrote; 

    #---- sum File
    #&msg("Writing plot data to $pl_sum_file"); 
    open(PL,">$pl_sum_file") || &error("Cannot open output $pl_sum_file - $!"); 
    $pl_cnt = 0;
    foreach $this_key (sort keys %pl_sum_vals)
    {
      print PL "$this_key $pl_sum_vals{$this_key}\n"; 
      $pl_cnt++; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_sum_file") if $debug_wrote; 
  }

  #---- Write CSV data
  if ($pl_ts)
  {
    #---- avg File
    #&msg("Writing CSV data to $csv_avg_file"); 
    open(CSV,">$csv_avg_file") || &error("Cannot open output $csv_avg_file - $!"); 
    print CSV "Timestamp,Value\n"; 
    $csv_cnt = 0;
    foreach $this_key (sort keys %pl_avg_vals)
    {
      print CSV "$this_key,$pl_avg_vals{$this_key}\n"; 
      $csv_cnt++; 
    }
    close(CSV); 
    &msg("Wrote $csv_cnt records to $csv_avg_file") if $debug_wrote; 

    #---- min File
    #&msg("Writing CSV data to $csv_min_file"); 
    open(CSV,">$csv_min_file") || &error("Cannot open output $csv_min_file - $!"); 
    print CSV "Timestamp,Value\n"; 
    $csv_cnt = 0;
    foreach $this_key (sort keys %pl_min_vals)
    {
      print CSV "$this_key,$pl_min_vals{$this_key}\n"; 
      $csv_cnt++; 
    }
    close(CSV); 
    &msg("Wrote $csv_cnt records to $csv_min_file") if $debug_wrote; 

    #---- max File
    #&msg("Writing CSV data to $csv_max_file"); 
    open(CSV,">$csv_max_file") || &error("Cannot open output $csv_max_file - $!"); 
    print CSV "Timestamp,Value\n"; 
    $csv_cnt = 0;
    foreach $this_key (sort keys %pl_max_vals)
    {
      print CSV "$this_key,$pl_max_vals{$this_key}\n"; 
      $csv_cnt++; 
    }
    close(CSV); 
    &msg("Wrote $csv_cnt records to $csv_max_file") if $debug_wrote; 

    #---- sum File
    #&msg("Writing CSV data to $csv_sum_file"); 
    open(CSV,">$csv_sum_file") || &error("Cannot open output $csv_sum_file - $!"); 
    print CSV "Timestamp,Value\n"; 
    $csv_cnt = 0;
    foreach $this_key (sort keys %pl_sum_vals)
    {
      print CSV "$this_key,$pl_sum_vals{$this_key}\n"; 
      $csv_cnt++; 
    }
    close(CSV); 
    &msg("Wrote $csv_cnt records to $csv_sum_file") if $debug_wrote; 
  }

  #---- Write WWW data
  if ($pl_ts)
  {
    #---- Header
    print "<h3> DBAmon METRICS ($m_title) Metric Data For: DBAmonMode=$mode InstanceKey=($instance)  MetricCategory=$in_categ Parm=$in_parm </h3>\n"; 
    print "<p><table border=0 bgcolor=wheat $style_normal >\n";
    print "<tr bgcolor=slateblue>
      <th $style_normal>Timestamp
      <th $style_normal>Instance
      <th $style_normal nowrap>Metric <br>Key 
      <th $style_normal>Metric<br> Parm <br>(If Any)
      <th $style_normal nowrap >Avg. 
      <th $style_normal nowrap >Min.
      <th $style_normal nowrap >Max.
      <th $style_normal nowrap >Sum
    ";
    print "<tr bgcolor=slateblue>
      <th $style_normal colspan=2 align=left>Glossary (If Any): 
      <th $style_normal nowrap>[$categ_desc]
      <th $style_normal nowrap>[$parm_desc] 
      <th $style_normal nowrap>
      <th $style_normal nowrap>
      <th $style_normal nowrap>
      <th $style_normal nowrap>
    ";
    print "<tr bgcolor=white>
      <th $style_normal colspan=4 align=right>Available Plots: 
      <td $style_normal align=center> <b> 
	<a href='$http_host/cgi-bin/dbamon_plot.pl?metricsSingleval,$pl_avg_file,$out_instance_db,$categ_desc/$m_title - Avg. Values'> Avg. Value Plot </a>  </b>
      <td $style_normal align=center> <b> 
	<a href='$http_host/cgi-bin/dbamon_plot.pl?metricsSingleval,$pl_min_file,$out_instance_db,$categ_desc/$m_title - Min. Values'> Min. Value Plot </a>  </b>
      <td $style_normal align=center> <b> 
	<a href='$http_host/cgi-bin/dbamon_plot.pl?metricsSingleval,$pl_max_file,$out_instance_db,$categ_desc/$m_title - Max. Values'> Max. Value Plot </a>  </b>
      <td $style_normal align=center> <b> 
	<a href='$http_host/cgi-bin/dbamon_plot.pl?metricsSingleval,$pl_sum_file,$out_instance_db,$categ_desc/$m_title - Sum Values'> Sum Value Plot </a>  </b>
    ";
    print "<tr bgcolor=white>
      <th $style_normal colspan=4 align=right>Available CSV Files: 
      <th nowrap> 
	<a href='/dbamon/dyn/$csv_avg_file_short'<b> Avg. Value CSV </b></a> 
      <th nowrap> 
	<a href='/dbamon/dyn/$csv_min_file_short'<b> Min. Value CSV </b></a> 
      <th nowrap> 
	<a href='/dbamon/dyn/$csv_max_file_short'<b> Max. Value CSV </b></a> 
      <th nowrap> 
	<a href='/dbamon/dyn/$csv_sum_file_short'<b> Sum Value CSV </b></a> 
    ";

    #---- Body
    $selectcount = 0; 
    foreach $this_key (sort { $b cmp $a }  keys %www_vals)
    {
      ##$diag .= "this_key=$this_key "; 
      print "$www_vals{$this_key}\n"; 

      if (++$selectcount > $maxrows) 
      { 
	print "<tr bgcolor=pink><td colspan=15><b><font size=2>MaxRows threshold of $maxrows exceeded - Rows will be processed for files, but no more will be displayed\n";
	last; 
      }
    }

    #---- Trailer
    print "</table>\n"; 
    &msg("Displayed $selectcount rows"); 
  }

  &msg("select_METRICS_Values - Done"); 
}

#-----------------------------------------------------------------------------
sub graph_METRICS_Values
#-----------------------------------------------------------------------------
{
  &msg("graph_METRICS_Values - Starting - in_categ=$in_categ in_parm=$in_parm min_max=$min_max in_days=$in_days"); 
  $s_time = time;

  $verbose = 0; 

  if ($in_days > 0) 
  {
    $and_days = "and ts > dateadd(dd, -$in_days, getdate())"; 
  }
  else
  {
    $and_days = ""; 
  }

  #if ($mode eq "test") 
  #{
  #  &msg("Since historical data is not collected for DBAmon TEST MODE at this time, exiting"); 
  #  return;
  #}

  &categExpand;

  #        -- and ts >= dateadd(dd,-183,getdate())
  #	--dbamon.dateconvert_19(ts), 
  #      order by ts desc

  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	ts, 
	system, 
	instance, 
        dbms,
	category, 
	parm,
	$min_max
      from 
	dbamon.$m_table 
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
        and category = '$in_categ'
        and parm = '$in_parm'   $and_days
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }

  &msg("  Querying DBAMON.$m_table - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  $cell_width = 60;

  if ($in_parm eq ".") 
  {
    $out_instance_db = "$instance"; 
  }
  else
  {
    $out_instance_db = "$instance $parm_desc: $in_parm"; 
  }

  &msg("  Query elapsed time: $elapsed seconds - Fetching results...");

  $selectcount = 0;
  $verbose = 0;
  $stop_displaying = 1;
  $s_time = time;

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $ts    = shift(@Data); 
    $sy    = shift(@Data);  
    $in    = shift(@Data);  
    $dbms  = shift(@Data);  
    $categ = shift(@Data);  
    $parm  = shift(@Data);  
    $only  = shift(@Data);  

    if ($verbose && ($selectcount / 200 == int($selectcount / 200)))
    { 
      &msg("Fetched $selectcount rows...");  
    }

    #---- Data for ploticus
    $pl_ts  = substr($ts,0,10) . "." . substr($ts,11,5); 
    #---- Do this since we're using the raw TS value
    $pl_ts =~ s/\-/\//g;
    $pl_only_vals{$pl_ts} = $only; 

    $verbose = 1 if time - $s_time > 3; 
  }

  if ($verbose)
  {
    &msg("Rows Selected: $selectcount - Writing results to file(s)...");
  }

  if ($selectcount == 0) 
  { 
    &msg("No history data found for instance: $instance");
  }

  #---- Write ploticus data
  if ($pl_ts)
  {
    #---- v1 (only) File
    ##&msg("Writing plot data to $pl_v1_file"); 
    open(PL,">$pl_v1_file") || &error("Cannot open output $pl_v1_file - $!"); 
    $pl_cnt    = 0;
    $pl_maxval = -1;
    foreach $this_key (sort keys %pl_only_vals)
    {
      $this_val = $pl_only_vals{$this_key};
      print PL "$this_key $pl_only_vals{$this_key}\n"; 
      $pl_cnt++; 
      $pl_maxval = $this_val if $this_val > $pl_maxval; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_v1_file") if $debug_wrote; 
  }

  if ($pl_cnt == 0)
  {
    &msg("No rows found, graph cannot be created"); 
    return;
  }

  #---- http://localhost/cgi-bin/dbamon_plot.pl?metricsSingleval,/opt/dbamon/dat/dyn/dbamon_metrics_max_20110323_161608_5688.txt,localhost_MSSQL1 Drive Letter: C,Drive Percent Full /Hourly Summarized Data - $min_max Values
  $ENV{'DBAMON_NOWEB'} = 1;
  $min_max_uc = uc $min_max;
  $min_max_uc = "Unsummarized" if $min_max_uc eq "VALUES"; 

  if ($in_label) { $categ_desc .= " ($in_label)"; } 

  ##$cmd = "./dbamon_plot.pl 'metricsSingleval,$pl_v1_file,$out_instance_db,$categ_desc/$m_title - $min_max_uc Values'"; 
  $cmd = "./dbamon_plot.pl 'metricsSingleval,$pl_v1_file,$out_instance_db,$categ_desc/$m_title'"; 

  if ($verbose) 
  {
    &msg("Invoking dbamon_plot.pl - cmd=$cmd"); 
  }
  else
  {
    ##&msg("Invoking dbamon_plot.pl to draw chart..."); 
  }

  system($cmd); 

  $la_num = 100; 
  #---- Show the last $lastnum values
  #---- $pl_cnt has the number of values
  $la_offset = $pl_cnt - $la_num; 
  $la_cnt = 0; 
  $la_metric = "$in_categ"; 
  $la_metric .= "/$in_parm" if $in_parm; 
  &msg("Most recent $la_num values:"); 

  print "<p><table border=0 bgcolor=wheat $style_normal >\n";
  print "<tr bgcolor=slateblue>
      <th><span $style_normal>Obs. #
      <th><span $style_normal>Timestamp
      <th><span $style_normal>Instance
      <th><span $style_normal>Metric
      <th nowrap ><span $style_normal>Value  
      <th nowrap colspan=2><span $style_normal>% Of<br> Max Value<br>($pl_maxval)   
    ";
  foreach $this_key (sort keys %pl_only_vals)
  {
    $this_val = $pl_only_vals{$this_key}; 
    $la_cnt++; 
    if ($la_cnt > $la_offset)
    {
      ##print  "<tr><td>$this_key <td>$pl_only_vals{$this_key}\n"; 
      $bg = "bgcolor=white"; 
      $la_pct = sprintf("%.2f", (($this_val / $pl_maxval) * 100 )); 
      $la_string = "=" x (int($la_pct) / 5); 
      $la_string .= ">"; 
      printf "<tr $bg>
	<td nowrap $style_normal align=right> &nbsp; $la_cnt. &nbsp;
	<td nowrap $style_normal> &nbsp; $this_key &nbsp;
	<td nowrap $style_normal> &nbsp; $instance &nbsp;
	<td nowrap $style_normal> &nbsp; $la_metric &nbsp;
	<td nowrap $style_normal align=right width=$cell_width> <b> $this_val </b> 
	<td zgcolor=wheat nowrap $style_normal align=right width=$cell_width> $la_pct%% 
	<td zgcolor=wheat nowrap $style_normal width=$cell_width> <zont color=gray>$la_string  </font>
      </tr>
      "; 
    }
  }
  print "</table>\n"; 

  &msg("graph_METRICS_Values - Done"); 
}

#-----------------------------------------------------------------------------
sub graph_MSSQL_Instance
#-----------------------------------------------------------------------------
{
  &msg("graph_MSSQL_Instance - Starting - in_categ=$in_categ in_parm=$in_parm"); 
  $s_time = time;

  #if ($mode eq "test") 
  #{
  #  &msg("Since historical data is not collected for DBAmon TEST MODE at this time, exiting"); 
  #  return;
  #}

  &categExpand;

  #        -- and ts >= dateadd(dd,-183,getdate())
  #	--dbamon.dateconvert_19(ts), 
  #      order by ts desc

  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	ts, 
	sum(max) / 1024
      from 
	dbamon.dbamon.metrics_daily
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
        and category = 'SPC_DB_USED'
      group by ts
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }

  &msg("  Querying DBAMON.DBAMON.metrics_daily - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  $cell_width = 60;

  if ($in_parm eq ".") 
  {
    $out_instance_db = "$instance"; 
  }
  else
  {
    $out_instance_db = "$instance $parm_desc: $in_parm"; 
  }

  &msg("  Query elapsed time: $elapsed seconds - Fetching results");

  $selectcount = 0;
  $verbose = 0;
  $s_time = time;

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $ts    = shift(@Data); 
    $only  = shift(@Data);  

    if ($verbose && ($selectcount / 200 == int($selectcount / 200)))
    { 
      &msg("Fetched $selectcount rows...");  
    }

    #---- Data for ploticus
    $pl_ts  = substr($ts,0,10) . "." . substr($ts,11,5); 
    #---- Do this since we're using the raw TS value
    $pl_ts =~ s/\-/\//g;
    $pl_only_vals{$pl_ts} = $only; 

    $verbose = 1 if time - $s_time > 3; 
  }

  ##&msg("Rows Selected: $selectcount");

  if ($selectcount == 0) 
  { 
    &msg("No history data found for instance: $instance");
  }

  #---- Write ploticus data
  if ($pl_ts)
  {
    #---- v1 (only) File
    ##&msg("Writing plot data to $pl_v1_file"); 
    open(PL,">$pl_v1_file") || &error("Cannot open output $pl_v1_file - $!"); 
    $pl_cnt = 0;
    foreach $this_key (sort keys %pl_only_vals)
    {
      print PL "$this_key $pl_only_vals{$this_key}\n"; 
      $pl_cnt++; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_v1_file") if $debug_wrote; 
  }

  if ($pl_cnt == 0)
  {
    &msg("No rows found, graph cannot be created"); 
    return;
  }

  #---- http://localhost/cgi-bin/dbamon_plot.pl?metricsSingleval,/opt/dbamon/dat/dyn/dbamon_metrics_max_20110323_161608_5688.txt,localhost_MSSQL1 Drive Letter: C,Drive Percent Full /Hourly Summarized Data - $min_max Values

  $categ_desc = "MSSQL Instance Total USED Space (GB)"; 
  $m_title    = "Summarized Daily"; 

  $ENV{'DBAMON_NOWEB'} = 1;
  $min_max_uc = uc $min_max;
  $cmd = "./dbamon_plot.pl 'metricsSingleval,$pl_v1_file,$out_instance_db,$categ_desc/$m_title - $min_max_uc Values'"; 
   &msg("Invoking dbamon_plot.pl - cmd=$cmd"); 
  system($cmd); 

  &msg("graph_MSSQL_Instance- Done"); 
}

#-----------------------------------------------------------------------------
sub select_MCURRENT_Values
#-----------------------------------------------------------------------------
{
  &msg("select_MCURRENT_Values - Starting - instance=$instance"); 
  $s_time = time;

  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	dbamon.dateconvert_19(ts), 
	system, 
	instance, 
        dbms,
	category, 
	parm,
	value,
        w_threshold,
        c_threshold,
        comment
      from 
	dbamon.metrics_current
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
      order by category, parm
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }

  &msg("Querying DBAMON.METRICS_CURRENT data for this instance - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  $cell_width = 60;

  if ($in_parm eq ".") 
  {
    $out_instance_db = "$instance"; 
  }
  else
  {
    $out_instance_db = "$instance $parm_desc: $in_parm"; 
  }

  &msg("Query elapsed time: $elapsed seconds");

  print "<h3> DBAmon CURRENT Metric Readings For: DBAmonMode=$mode InstanceKey=($instance)  </h3>\n"; 
  print "<p><table border=0 bgcolor=wheat $style_normal >\n";
  # <th><span $style_normal>Server 
  # <th><span $style_normal>Instance
  # <th><span $style_normal>DBMS
  print "<tr bgcolor=slateblue>
    <th $style_normal nowrap>Metric <br>Key 
    <th $style_normal>Metric<br> Parm <br>(If Any)
    <th $style_normal>Timestamp<br> Of Most Recent<br>Reading of this<br>Metric
    <th $style_normal>Hours Since This Reading Was Taken 
    <th $style_normal nowrap >Value  
    <th $style_normal nowrap >Warning<br> Threshold<br> (If Any)  
    <th $style_normal nowrap >Critical<br> Threshold<br> (If Any)  
    <th $style_normal nowrap >Comments<br> (If Any)  
  ";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $ts    = shift(@Data); 
    $sy    = shift(@Data);  
    $in    = shift(@Data);  
    $dbms  = shift(@Data);  
    $categ = shift(@Data);  
    $parm  = shift(@Data);  
    $val   = shift(@Data);  
    $w_t   = shift(@Data);  
    $c_t   = shift(@Data);  
    $comm  = shift(@Data);  

    $val = "" if $val == -1; 

    $ts_num = &timeToNum($ts); 
    $secs_since = time - $ts_num;
    $hours_since = sprintf("%.2f", ($secs_since / 3600)); 
    if ($hours_since > 2) { $age_color = 'pink'; }
    else                  { $age_color = ''; }

    $bg = &bgRow;

    if ($w_t > 0 || $c_t > 0)
    {
      if    ($val >= $c_t) { $val_color = "pink"; }
      elsif ($w_t > 0 && $val >= $w_t) { $val_color = "yellow"; }
      else                 { $val_color = "lime"; }
    }
    else
    {
      $val_color = ""; 
    }

    # <td $style_normal nowrap> &nbsp; $sy &nbsp;
    # <td $style_normal nowrap> &nbsp; $in &nbsp;
    # <td $style_normal nowrap> &nbsp; $dbms &nbsp;
    print "<tr $bg>
      <td $style_normal nowrap> &nbsp; <b> $categ </b> &nbsp;
      <td $style_normal nowrap> &nbsp; <b> $parm </b> &nbsp;
      <td $style_normal nowrap> &nbsp; $ts &nbsp;
      <td $style_normal  nowrap align=right bgcolor='$age_color' > &nbsp; <b> $hours_since </b> &nbsp;
      <td $style_normal  nowrap align=right bgcolor='$val_color'> &nbsp; <b> $val </b> &nbsp;
      <td $style_normal  nowrap align=right > &nbsp; <b> $w_t </b> &nbsp;
      <td $style_normal  nowrap align=right > &nbsp; <b> $c_t </b> &nbsp;
      <td $style_normal nowrap> &nbsp; <b> $comm </b> &nbsp;
    ";
  }

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }
  print "</table>\n";
  &msg("Rows Selected: $selectcount");

  &msg("select_MCURRENT_Values - Done"); 
}

#-----------------------------------------------------------------------------
sub select_METRICS_ValuesRaw
#-----------------------------------------------------------------------------
{
  &msg("select_METRICS_ValuesRaw() - Starting - in_categ=$in_categ"); 
  $s_time = time;

  &categExpand;

  #     -- and ts >= dateadd(dd,-183,getdate())
  #   order by ts desc

  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	dbamon.dateconvert_19(ts), 
	system, 
	instance, 
        dbms,
	category, 
	parm,
	value
      from 
	dbamon.$m_table 
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
        and category = '$in_categ'
        and parm = '$in_parm'
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }
  &msg("DEBUG - sql=$sql") if $debug; 

  &msg("Querying DBAMON.$m_tble data for this instance");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  $cell_width = 60;

  if ($in_parm eq ".") 
  {
    $out_instance_db = "$instance"; 
  }
  else
  {
    $out_instance_db = "$instance $parm_desc: $in_parm"; 
  }

  &msg("Query elapsed time: $elapsed seconds - Writing results to file(s)...");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 

    $ts    = shift(@Data); 
    $sy    = shift(@Data);  
    $in    = shift(@Data);  
    $dbms  = shift(@Data);  
    $categ = shift(@Data);  
    $parm  = shift(@Data);  
    $val   = shift(@Data);  

    #$bg = &bgRow;
    $bg = "bgcolor=white"; 

    if ($categ_desc ne $categ) { $zcat = "($categ_desc)" } 
    else                       { $zcat = "" } 

    #---- Format DATE hash key 
    $pl_ts  = substr($ts,0,10) . "." . substr($ts,11,5); 

    #---- Data for ploticus
    $pl_val_vals{$pl_ts} = $val; 

    $www_vals{$pl_ts} = sprintf "<tr $bg>
	<td nowrap $style_normal> &nbsp; $ts &nbsp;
	<td nowrap $style_normal> &nbsp; $in &nbsp;
	<td nowrap $style_normal> &nbsp; <b> $categ $zcat </b> &nbsp;
	<td nowrap $style_normal> &nbsp; <b> $parm </b> &nbsp;
	<td nowrap $style_normal align=right width=$cell_width> <b> $val </b> 
      </tr>
      "; 
  }

  if ($selectcount == 0) 
  { 
    &msg("No event history data found for instance: $instance");
  }
  &msg("Rows Selected: $selectcount");

  #---- Write ploticus data
  if ($pl_ts)
  {
    #---- val File
    &msg("Writing plot data to $pl_val_file"); 
    open(PL,">$pl_val_file") || &error("Cannot open output $pl_val_file - $!"); 
    $pl_cnt = 0;
    foreach $this_key (sort keys %pl_val_vals)
    {
      print PL "$this_key $pl_val_vals{$this_key}\n"; 
      $pl_cnt++; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_val_file") if $debug_wrote; 
  }

  #---- Write CSV data
  if ($pl_ts)
  {
    #---- val File
    &msg("Writing CSV data to $csv_val_file"); 
    open(CSV,">$csv_val_file") || &error("Cannot open output $csv_val_file - $!"); 
    print CSV "Timestamp,Value\n"; 
    $csv_cnt = 0;
    foreach $this_key (sort keys %pl_val_vals)
    {
      print CSV "$this_key,$pl_val_vals{$this_key}\n"; 
      $csv_cnt++; 
    }
    close(CSV); 
    &msg("Wrote $csv_cnt records to $csv_val_file") if $debug_wrote; 
  }

  #---- Write WWW data
  if ($pl_ts)
  {
    #---- Header
    print "<h3> DBAmon METRICS ($m_title) Metric Data For: DBAmonMode=$mode InstanceKey=($instance) MetricCategory=$in_categ Parm=$in_parm </h3>\n"; 

    print "<p><table border=0 bgcolor=wheat $style_normal >\n";
    print "<tr bgcolor=slateblue>
      <th $style_normal>Timestamp
      <th $style_normal>Instance
      <th $style_normal nowrap>Metric <br>Key 
      <th $style_normal>Metric<br> Parm <br>(If Any)
      <th $style_normal nowrap >Value  
    ";
    print "<tr bgcolor=slateblue>
      <th $style_normal colspan=2 align=left>Glossary (If Any): 
      <th $style_normal nowrap>[$categ_desc]
      <th $style_normal nowrap>[$parm_desc] 
      <th $style_normal nowrap>
    ";
    print "<tr bgcolor=white>
      <th $style_normal colspan=4 align=right>Available Plots: 
      <td $style_normal align=center> <b> 
	<a href='$http_host/cgi-bin/dbamon_plot.pl?metricsSingleval,$pl_val_file,$out_instance_db,$categ_desc/$m_title - Raw Values'> Raw Value Plot </a>  </b>
    ";
    print "<tr bgcolor=white>
      <th $style_normal colspan=4 align=right>Available CSV Files: 
      <th nowrap> 
	<a href='/dbamon/dyn/$csv_val_file_short'<b> Raw Value CSV </b></a> 
    ";

    #---- Body
    $selectcount = 0; 
    foreach $this_key (sort { $b cmp $a }  keys %www_vals)
    {
      ##$diag .= "this_key=$this_key "; 
      print "$www_vals{$this_key}\n"; 

      if (++$selectcount > $maxrows) 
      { 
	print "<tr bgcolor=pink><td colspan=15><b><font size=2>MaxRows threshold of $maxrows exceeded - Rows will be processed for files, but no more will be displayed\n";
	last; 
      }
    }

    #---- Trailer
    print "</table>\n"; 
  }

  ##&msg("DEBUG - diag=$diag"); 

  &msg("select_METRICS_ValuesRaw - Done"); 
}

#-----------------------------------------------------------------------------
sub selectHISTORYDataDetail
#-----------------------------------------------------------------------------
{
  &msg("selectHISTORYDataDetail - Starting - in_categ=$in_categ"); 
  $s_time = time;

  $v4_desc = ""; 
  if ($in_categ eq "SPC")        { $categ_desc = "DB Space Utilization";   $parm_desc = "DBName"; $v1_desc = "MB Allocated"; $v2_desc = "MB Used"; $v3_desc = ".";  } 
  if ($in_categ eq "SERVER_MEM") { $categ_desc = "Server RAM Utilization"; $parm_desc = "N/A";    $v1_desc = "RAM % Used";   $v2_desc = "Total RAM";  $v3_desc = "Used RAM";  } 
  if ($in_categ eq "TLOG_RATIO") { $categ_desc = "TLog/DBSize Ratio";      $parm_desc = "DBName"; $v1_desc = "TL/DB Ratio";  $v2_desc = "TLog Size";  $v3_desc = "DB Size";   } 

  $categ_desc = $in_categ if ! $categ_desc;

  # Create the SQL SELECT statement
  if ($dbamon_repos eq "M")
  {
    $sql  = "
      select 
	dbamon.dateconvert_19(ts), 
	system, 
	instance, 
        dbms,
	category, 
	parm,
	value,
	value2,
	value3,
	value4 
      from 
	dbamon.history 
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
        and category = '$in_categ'
        and parm = '$in_parm'
	and ts >= dateadd(dd,-183,getdate())
      order by ts desc
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }
  &msg("DEBUG - sql=$sql") if $debug; 

  &msg("Querying DBAMON.HISTORY data for this instance for the last six months");
  ##&msg("WHERE Clause: instance = '$instance' $where2 $where3");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  $cell_width = 60;

  if ($in_parm eq ".") 
  {
    $out_instance_db = "$instance"; 
  }
  else
  {
    $out_instance_db = "$instance DB: $in_parm"; 
  }

  &msg("Query elapsed time: $elapsed seconds");

  print "<h3> DBAmon HISTORY (1 Random Observation Per Day) Metric Data For: <br> DBAmonMode=$mode InstanceKey=($instance) MetricCategory=$in_categ Parm=$in_parm </h3>\n"; 
  print "<p><table border=0 bgcolor=wheat $style_normal >\n";
  print "<tr bgcolor=slateblue>
    <th><span $style_normal>Timestamp
    <th><span $style_normal>Server 
    <th><span $style_normal>Instance
    <th><span $style_normal>DBMS
    <th nowrap><span $style_normal>Metric <br>Key 
    <th><span $style_normal>Metric<br> Parm <br>(If Any)
    <th nowrap><span $style_normal>Value1
    <th nowrap><span $style_normal>Value2
    <th nowrap><span $style_normal>Value3
    <th nowrap><span $style_normal>Value4
  \n";
  print "<tr bgcolor=slateblue>
    <th colspan=4 align=left><span $style_normal>Glossary (If Any): 
    <th nowrap><span $style_normal>[$categ_desc]
    <th nowrap><span $style_normal>[$parm_desc] 
    <th nowrap><span $style_normal>[$v1_desc]
    <th nowrap><span $style_normal>[$v2_desc]
    <th nowrap><span $style_normal>[$v3_desc]
    <th nowrap><span $style_normal>[$v4_desc]
  \n";
  print "<tr bgcolor=white>
    <th colspan=6 align=right><span $style_normal>Available Plots: 
    <td $style_normal align=center> <b> <a href='$http_host/cgi-bin/dbamon_plot.pl?metricsSingleval,$pl_v1_file,$out_instance_db,$categ_desc/$v1_desc'> Value1 Plot </a>  </b>
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
  \n";
  print "<tr bgcolor=white>
    <th colspan=6 align=right><span $style_normal>Available CSV Files: 
    <th nowrap> <a href='/dbamon/dyn/$csv_v1_file_short'<b> Value1 CSV </b></a> 
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts    = shift(@Data); 
    $sy    = shift(@Data);  
    $in    = shift(@Data);  
    $dbms  = shift(@Data);  
    $categ = shift(@Data);  
    $parm  = shift(@Data);  
    $v1    = shift(@Data);  
    $v2    = shift(@Data);  
    $v3    = shift(@Data);  
    $v4    = shift(@Data);  

    $bg = &bgRow;

    print "<tr $bg>
      <td $style_normal> $ts 
      <td $style_normal> $sy 
      <td $style_normal> $in 
      <td $style_normal> $dbms 
      <td $style_normal> <b> $categ ( $categ_desc ) </b>
      <td $style_normal> <b> $parm </b>
      <td $style_normal align=right width=$cell_width> <b> $v1 </b>
      <td $style_normal align=right width=$cell_width> <b> $v2 </b>
      <td $style_normal align=right width=$cell_width> <b> $v3 </b>
      <td $style_normal align=right width=$cell_width> <b> $v4 </b>
    " if ! $stop_displaying; 

    #---- Data for ploticus
    $pl_ts  = substr($ts,0,10) . "." . substr($ts,11,5); 

    $pl_v1_vals{$pl_ts} = $v1; 

    if (++$selectcount > $maxrows && ! $stop_displaying) 
    { 
      print "<tr bgcolor=pink><td colspan=15><b><font size=2>MaxRows threshold of $maxrows exceeded - Rows will be processed for files, but no more will be displayed\n";
      print "</table>\n";
      $stop_displaying = 1; 
    }
  }

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }
  print "</table>\n";
  &msg("Rows Selected: $selectcount");

  #---- Write ploticus data
  if ($pl_ts)
  {
    #---- v1 File
    &msg("Writing plot data to $pl_v1_file"); 
    open(PL,">$pl_v1_file") || &error("Cannot open output $pl_v1_file - $!"); 
    $pl_cnt = 0;
    foreach $this_key (sort keys %pl_v1_vals)
    {
      print PL "$this_key $pl_v1_vals{$this_key}\n"; 
      $pl_cnt++; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_v1_file") if $debug_wrote; 
  }

  #---- Write CSV data
  if ($pl_ts)
  {
    #---- v1 File
    &msg("Writing CSV data to $csv_v1_file"); 
    open(CSV,">$csv_v1_file") || &error("Cannot open output $csv_v1_file - $!"); 
    print CSV "Timestamp,Value\n"; 
    $csv_cnt = 0;
    foreach $this_key (sort keys %pl_v1_vals)
    {
      print CSV "$this_key,$pl_v1_vals{$this_key}\n"; 
      $csv_cnt++; 
    }
    close(CSV); 
    &msg("Wrote $csv_cnt records to $csv_v1_file") if $debug_wrote; 
  }
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{

   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

&get_request;

@words = split(/,/,$ARGV[0]);
$mode     = shift @words;
$instance = shift @words; 
$in_categ = shift @words; 
$in_parm  = shift @words; 
$in_days  = shift @words; 
$in_label = shift @words; 

&header("Metrics - Data/Chart Viewer") unless $ENV{'DBAMON_NOWEB'}; 
&msg("Starting - version=$version - mode=($mode) verb=($verb) instance=($instance) in_categ=($in_categ) in_parm=($in_parm) in_days=($in_days) in_label=($in_label) - maxrows=$maxrows - http_host=($http_host)");

&setStyles;

&connectDB;


&select_MCURRENT_Values;
&msg("Done");
exit 0;


$verb = "MENU" if ! $verb;

#---- Call according to parms passed 
if (! $mode) 
{ 
  &error("MODE (1st parm) Must be specified");
}

if ($verb eq "MENU") 
{
  if ($instance) { &menuInstance; }
  else           { &menuMain; }
}
elsif ($verb eq "PTEST") 
{
  &msg("Exiting"); 
  ##&msg("zdiag=<pre>$zdiag</pre>"); 
  exit 0; 
}
elsif ($verb eq "HISTORY") 
{
  #if ($mode && ! $instance)   #---- This should never happen #{ #  &menuMain; #}
  if    ($instance && $in_categ) { &selectHISTORYDataDetail; }
  elsif ($instance )             { &selectHISTORYDataInstance; }
  else { &error("Unknown parameters passed (verb=$verb)"); }
}
elsif ($verb eq "MCURRENT") 
{
  &select_MCURRENT_Values;
}
elsif ($verb eq "MSSQL_INSTANCE_SIZE") 
{
  &graph_MSSQL_Instance; 
}
elsif ($verb =~ /^M/ || $verb =~ /^G/ ) 
{
  if ($verb eq "MDETAIL")
  {
    $m_table = "METRICS_DETAIL"; 
    $m_title = "Detail Raw Data"; 
    $min_max = "min(value), max(value)"; 
    $mode_raw = 1;
  }
  elsif ($verb eq "MDAILY")
  {
    $m_table = "METRICS_DAILY"; 
    $m_title = "Daily Summarized Data"; 
    $min_max = "min(min), max(max)"; 
    $mode_raw = 0;
  }
  elsif ($verb eq "MHOURLY")
  {
    $m_table = "METRICS_HOURLY"; 
    $m_title = "Hourly Summarized Data"; 
    $min_max = "min(min), max(max)"; 
    $mode_raw = 0;
  }
  elsif ($verb eq "GHOURLY")
  {
    $m_table = "METRICS_HOURLY"; 
    $m_title = "Hourly Summarized Data"; 
    $min_max = "max"; 
  }
  elsif ($verb eq "GDAILY")
  {
    $m_table = "METRICS_DAILY"; 
    $m_title = "Daily Summarized MAX Values"; 
    $min_max = "max"; 
  }
  elsif ($verb eq "GRAW")
  {
    $m_table = "METRICS_DETAIL"; 
    if ($in_days > 0) 
    {
      $m_title = "Raw Data - Last $in_days Days"; 
    }
    else
    {
      $m_title = "Raw Data"; 
    }
    $min_max = "value"; 
  }
  else { &error("Unknown parameters passed L809 (verb=$verb)"); }

  if    ($instance && $in_categ) 
  {
    if ($verb =~ /^G/) 
    { 
      &graph_METRICS_Values; 
    }
    else
    {
      if ($mode_raw) { &select_METRICS_ValuesRaw; }
      else          
      { 
        &select_METRICS_Values; 
      }
    }
  }
  elsif ($instance )             { &select_METRICS_Instance; }
  else { &error("Unknown parameters passed (verb=$verb)"); }
}
else 
{ 
  &error("Unknown verb=($verb) passed");
}

#---- Terminate
&msg("Done");
exit 0;
