#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sum.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

$| = 1;
$P = "dbamon_ora_histread.pl";
$tmpflrpt = "/tmp/dbamon_ora_eventrpt_1_$$.txt";
$tmpflemail = "/tmp/dbamon_ora_eventrpt_2_$$.txt";

$days = 5;
$img = "http://theserver.cos.thecompany.com/images/blue.gif";

#######################################################################
# Customize Here:
#$dest_server = "curley";
#$dest_dir    = "/tmp/sas/";
#$dest_user   = "border";
#######################################################################

$ENV{'ORACLE_SID'}  = $ORACLE_SID;
$ENV{'ORACLE_HOME'} = $ORACLE_HOME;
$old_path           = $ENV{"PATH"};
$ENV{'PATH'}        = "$ORACLE_HOME/bin:${old_path}";

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$mode = uc $ARGV[0];
#$modelc = lc $mode;
if ($mode eq "") { $mode = "PROD"; }

$modesuf = "_test" if $modelc eq "test"; 
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
chop($admin_email = `grep Admin_EMail: /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
$email = $admin_email;

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
#$arg5 = $ARGV[5];
#$arg6 = $ARGV[6];
#$arg7 = $ARGV[7];
#$arg8 = $ARGV[8];
$email = $admin_email if $arg1 ne "";

&msg("mode=$mode");
if ($mode ne "TEST" && $mode ne "PROD")
{
  print "$P | Usage: $0 {test | prod}\n";
  exit 1;
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  system("rm $tmpflrpt");
  system("rm $tmpflemail");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#-----------------------------------------------------------------------------
sub sumRpt2
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print RPT "<h5><hr>DBAmon Event Summary - Last $days Days - By DBMS (Rpt2)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate><th><font size=2>DBMS</font><th><font size=2>Event Count</font><th><font size=2>% Of Total</font>\n";

  $statement  = "
select
  count(*)
from 
  dbamon.events
where 
  ts >= sysdate - $days
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $daystot = $Data[0];
  }

  $statement  = "
    select
      dbms, 
      count(*)
    from 
      dbamon.events
    where 
      ts >= sysdate - $days
    group by
      dbms
    order by 
      2 desc ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $dbms = $Data[0];
    $cnt  = $Data[1];

    $pct = ($cnt / $daystot) * 100;
    $pct = sprintf("%11.1f",$pct);
    #printf RPT "%-16s %11.0f %11.1f%% \n",$dbms,$cnt,$pct;
    print RPT "<tr>
       <td><font size=2>$dbms<td align=right><font size=2>$cnt<td align=right><font size=2>${pct}%</font>\n";
    
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$daystot\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
  &msg("Total events: $daystot");
}


#-----------------------------------------------------------------------------
sub sumRpt5
#-----------------------------------------------------------------------------
{
  &msg("sumRpt5 - Selecting");

  print RPT "<a name=rpt5>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By MsgID - Last 24 Hours (Rpt5)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate><th><font size=2>MsgId</font><th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 1 
    group by
      msgid 
    --having count(*) > 4
    order by
      2 desc";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $msgid = $Data[0];
    $count = $Data[1];

    $total += $count;

    $z = $count ;

    print RPT "<tr>
       <td><font size=2>$msgid
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print RPT "</table>\n";

  $daytotal = $total;

  &msg("Selected $selectcount rows - daytotal=$daytotal");
}

#-----------------------------------------------------------------------------
sub sumRpt5d
#-----------------------------------------------------------------------------
{
  &msg("sumRpt5d - Selecting");

  print RPT "<a name=rpt5d>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By Instance And MsgID - Last 24 Hours (Rpt5d)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate>
    <th><font size=2>Instance</font>
    <th><font size=2>Msgid</font>
    <th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      title,
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 1 
    group by
      title,
      msgid 
    --having count(*) > 4
    order by
      3 desc";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $title = $Data[0];
    $msgid = $Data[1];
    $count = $Data[2];

    $total += $count;

    $z = $count ;

    print RPT "<tr>
       <td><font size=2>$title
       <td><font size=2>$msgid
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print RPT "</table>\n";

  $daytotal = $total;

  &msg("Selected $selectcount rows - daytotal=$daytotal");
}





#-----------------------------------------------------------------------------
sub sumRpt3
#-----------------------------------------------------------------------------
{
  &msg("sumRpt3 - Selecting");

  print RPT "<a name=rpt3>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By MsgID - Last Week (Rpt3)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate><th><font size=2>DBMS</font><th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 7 
    group by
      msgid
    order by
      2 desc ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $msgid = $Data[0];
    $count = $Data[1];

    $total += $count;

    $z = $count;

    print RPT "<tr>
       <td><font size=2>$msgid
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}


#-----------------------------------------------------------------------------
sub sumRpt3d
#-----------------------------------------------------------------------------
{
  &msg("sumRpt3d - Selecting");

  print RPT "<a name=rpt3d>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By Instance And MsgID - Last Week (Rpt3d)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate>
    <th><font size=2>Instance</font>
    <th><font size=2>MsgId</font>
    <th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      title,
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 7 
    group by
      title,
      msgid
    having count(*) > 4
    order by
      3 desc ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $title   = $Data[0];
    $msgid   = $Data[1];
    $count   = $Data[2];

    $total += $count;

    $z = $count;

    print RPT "<tr>
       <td><font size=2>$title
       <td><font size=2>$msgid
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}

#-----------------------------------------------------------------------------
sub sumRpt3e
#-----------------------------------------------------------------------------
{
  &msg("sumRpt3e - Selecting");

  print RPT "<a name=rpt3d>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By Instance And MsgID - Last Six Months (Rpt3e)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate>
    <th><font size=2>Instance</font>
    <th><font size=2>MsgId</font>
    <th><font size=2>Event Text</font>
    <th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      title,
      msgid,
      text,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 180 
    having
      count(*) > 100
    group by
      title,
      msgid,
      text
    order by
      4 desc ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $title   = $Data[0];
    $msgid   = $Data[1];
    $text    = $Data[2];
    $count   = $Data[3];

    $total += $count;

    $z = $count;

    print RPT "<tr>
       <td><font size=2>$title
       <td><font size=2>$msgid
       <td><font size=1>$text
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}


#-----------------------------------------------------------------------------
sub sumRpt6
#-----------------------------------------------------------------------------
{
  &msg("sumRpt6 - Selecting");

  print RPT "<a name=rpt6>\n";
  print RPT "<h5><hr>DBAmon Critical Event Report - Count Grouped By Date - Last 180 Days (Rpt6)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate><th><font size=2>DBMS</font><th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      to_char(ts,'YYYY/MM/DD') newts,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 180 
      and ticket is null
    group by
      to_char(ts,'YYYY/MM/DD') 
    order by 1 desc
    ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $date  = $Data[0];
    $count = $Data[1];

    $total += $count;

    $z = int($count / 10);

    print RPT "<tr>
       <td><font size=2>$date
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}


#-----------------------------------------------------------------------------
sub sumRpt4
#-----------------------------------------------------------------------------
{
  &msg("sumRpt4 - Selecting");

  print RPT "<a name=rpt4>\n";
  print RPT "<h5><hr>DBAmon Critical Event Report - Count Grouped By Month - Last Year (Rpt4)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate><th><font size=2>DBMS</font><th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      to_char(ts,'YYYY/MM') newts,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 365 
      and ticket is null
    group by
      to_char(ts,'YYYY/MM') ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $date  = $Data[0];
    $count = $Data[1];

    $total += $count;

    $z = int($count / 200);

    print RPT "<tr>
       <td><font size=2>$date
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}


#-----------------------------------------------------------------------------
sub msgidRpt
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print RPT "<a name=rptmsgid>\n";
  print RPT "<h5><hr>DBAmon MsgId Legend</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate>
    <th><font size=2>MsgId</font>
    <th><font size=2>Example Text</font>\n";

  $statement  = "
select
  msgid,
  min(text)
from 
  dbamon.event_history
group by
  msgid
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $msgid = $Data[0];
    $text  = $Data[1];

    printf RPT "<tr>
      <td><font size=2>$msgid
      <td><font size=2>$text
       \n";

  }

  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}


#-----------------------------------------------------------------------------
sub sumRpt
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print RPT "<h5><hr>DBAmon Event Count - Last $days Days</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate>
    <th><font size=2>Date</font>
    <th><font size=2>DBMS</font>
    <th><font size=2>Event Count</font>\n";

  $statement  = "
select
  to_char(ts,'YYYY/MM/DD') newts,
  dbms, 
  count(*)
from 
  dbamon.events
where 
  ts >= sysdate - $days
group by
  to_char(ts,'YYYY/MM/DD') ,
  dbms
order by 
  1 desc ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $date = $Data[0];
    $dbms = $Data[1];
    $cnt  = $Data[2];

    if ($date ne $lastdate && $lastdate ne "")
    {
      printf RPT "<tr><td><td><td bgcolor=slate align=right ><font size=2><b>Day Total:</b> $dsubcnt \n";
      $dsubcnt = 0;
    }

    printf RPT "<tr>
      <td><font size=2>$date
      <td><font size=2>$dbms
      <td align=right><font size=2>$cnt \n";

    $dtotal  += $cnt;
    $dsubcnt += $cnt;
    $lastdate = $date;
  }

  printf RPT "<tr><td><td><td bgcolor=slate align=right><font size=2><b>Day Total:</b> $dsubcnt \n";

  printf RPT "<tr bgcolor=slate><th><font size=2>Total:<td><td align=right><font size=2>$dtotal\n";;
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
  &msg("Total events: $dtotal");
}




#-----------------------------------------------------------------------------
sub detailRpt
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print RPT "<h5><hr>DBAmon Event Detail - Last 24 Hours</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate>
        <th><font size=2>Instance</font>
        <th><font size=2>DBMS</font>
        <th><font size=2>Severity</font>
        <th><font size=2>Event Count</font>
        \n";

  $statement  = "select
      instance,
      dbms,
      sev,
      count(*)
    from 
      dbamon.events
    where 
      ts >= sysdate - 1
    group by
      instance,
      dbms,
      sev
    order by 
      4 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $inst = $Data[0];
    $dbms = $Data[1];
    $sev  = $Data[2];
    $cnt  = $Data[3];
    $firstinst = "$inst($dbms)" if $firstinst eq "";
    #printf RPT "%-28s %-16s %-4s %11.0f \n",$inst,$dbms,$sev,$cnt;

    printf RPT "<tr>
      <td><font size=2>$inst
      <td><font size=2>$dbms
      <td><font size=2>$sev
      <td align=right><font size=2>$cnt
    \n";

    ##print "DEBUG: $zdat $inst $dbms $cat $parm $val \n";
    $total += $cnt;
  }
  printf RPT "<tr bgcolor=slate>
      <th><font size=2>Total:
      <td><font size=2>
      <td><font size=2>
      <td align=right><font size=2>$total
    \n";
  print  RPT "</table> \n";

  &msg("Selected $selectcount rows");
  &msg("Total events: $total");
}

#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  chop($hostname = `hostname`);
  chop($date = `date`);

  msg("Opening output RPT file: $tmpflrpt");
  system("rm $tmpflrpt 2>/dev/null");
  open(RPT, ">$tmpflrpt") || &error("Can't open output $tmpflrpt - $!");

  msg("Opening output EMAILHDR file: $tmpflemail");
  system("rm $tmpflemail 2>/dev/null");
  open(EMAILHDR, ">$tmpflemail") || &error("Can't open output $tmpflemail - $!");
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 - hostname=$hostname");

&connectDB;
&init;

## Make header
#&sumRpt5; 
##&detailRpt; 
#close(RPT);
#system("rm $tmpflrpt $tmpflemail");
#$firstinst =~ s/ //g;

#&init;

print EMAILHDR "Subject: ***[DBAmon Report]*** Events - $daytotal Critical Events During Last 24 Hours [AUTO]\n";
print EMAILHDR "Content-type: text/html \n\n";
print EMAILHDR "
<html>
<font face=verdana size=2>
<table border=0 width=90%>
<tr bgcolor=darkblue><td><center><font color=white size=6>DBAmon</font></center>
<tr bgcolor=wheat><td><center><b>Daily Event Reports - As Of: $date</b></center>
</table> \n";
print EMAILHDR "<p><center>In an effort to conserve Network and EMail bandwidth, this report is now
available on the WWW. 
<p><a href='http://dba.it.thecompany.com/dba/data/reportcache/$P.html'><b>Click Here To View The Report</b></a>\n";
close(EMAILHDR);

print RPT "
<html>
<font face=verdana size=2>
<table border=0 width=90%>
<tr bgcolor=darkblue><td><center><font color=white size=6>DBAmon</font></center>
<tr bgcolor=wheat><td><center><b>Daily Event Reports - As Of: $date</b></center>
</table> \n";

print RPT "
  <br><b>Reports:</b>
  <ul>
    <li><a href='#rpt5' ><b>Critical Events During the Last 24 Hours - By MsgId</b></a>
    <li><a href='#rpt5d'><b>Critical Events During the Last 24 Hours - By Instance And MsgId</b></a>
    <li><a href='#rpt3' ><b>Critical Events During the Last 7 Days - By MsgId</b></a>
    <li><a href='#rpt3d'><b>Critical Events During the Last 7 Days - By Instance And MsgId</b></a>
    <li><a href='#rpt4' ><b>Critical Events Count During The Last Year - By Month</b></a>
    <li><a href='#rpt6' ><b>Critical Events Count During The 90 Days - By Date (NEW)</b></a>
    <li><a href='#rptmsgid' ><b>DBAmon MsgId Legend</b></a>
  </ul>
  ";


&sumRpt5; 
&sumRpt5d; 
&sumRpt3; 
&sumRpt3d; 
&sumRpt3e; 
&sumRpt4; 
&sumRpt6; 
&msgidRpt; 

#&sumRpt2; 
#&sumRpt; 
#&detailRpt; 

close(RPT);

&msg("Sending email header to $email");
system("cat $tmpflemail");
system("cat $tmpflemail | sendmail $email");

$cachefile = "/opt/web/dba/data/reportcache/$P.html";
&msg("Copying report body to / email header to $cachefile");
system("cp $tmpflrpt $cachefile");

system("rm $tmpflemail $tmpflemail");

&msg("Done");
exit 0;
