#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sum.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

#$color = "darkblue";
$| = 1;
$P = "dbamon_www_email.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$tmpfile = "/tmp/${P}_$$.txt";
#$font = "verdana";

$this_hostname = $ARGV[0];
$this_domain   = $ARGV[1];
$this_title1   = $ARGV[2];

$ckin =  $ARGV[3];

$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=lightgrey"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  ##&msg("Connecting to DBAmon Oracle Repository DB to read DBC data");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#------------------------------------------------------------------------------
sub connectDBSTAR
#------------------------------------------------------------------------------
{
  ##&msg("Connecting to STAR Oracle DB");
  use DBI;
  $user = "stargazer";
  $passwd = "i0ndrive";
  $data_source = "DBI:Oracle";
  $database = "STAR";

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
}



#-----------------------------------------------------------------------------
sub getSTAR
#-----------------------------------------------------------------------------
{
  &msg("Selecting EMail data from STARS for Host/Domain/Instance $this_hostname/$this_domain/$this_title1");

  if ($this_title1 eq "MSSQL")
  {
    $this_title1 = "";
  }
  if ($this_title1 ne "")
  {
    $and_stmt = "and app_instance_nm = '$this_title1'"
  }

    #SELECT distinct ldap_emailaddress
    #SELECT distinct ldap_emailaddress, APP_ROLE_NM

  # Count tasks
  $statement  = "
    SELECT distinct ldap_emailaddress, APP_ROLE_NM
    FROM 
      staradm.vwactiveserver v, 
      staradm.srvrapp a, 
      --staradm.contact c, 
      staradm.vwcontactgazer c, 
      staradm.srvrapprolecontact r
    WHERE v.server_id = a.server_id
    and a.srvr_app_id = r.srvr_app_id
    and r.ldap_uid = c.ldap_uid
    and app_type_nm = 'Database'
    and host_nm = '$this_hostname' 
    and dns_domain = '$this_domain'
    $and_stmt
    order by 2, 1
  ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $rowcount = 0;
  $rowflag  = 0;
  
  while (@Data = $sth->fetchrow_array)
  {
    if ($rowflag == 0)
    {
      print "\n<table border=1>
        <tr bgcolor=slate>
          <th><font size=2>Role
          <th><font size=2>Contact
      ";
      $rowflag = 1;
    }

    if (index($email_addresses,$Data[0]) == -1)
    { 
      $email_addresses .= "$Data[0]" . ';';
      $rowcount++;
    }

    #&msg("Found email address: <b>$Data[0]</b>");
    print "<tr bgcolor=skyblue><td><font size=2>$Data[1] <td><font size=2>$Data[0] \n";
  }
  
  if ($rowcount > 0)
  {
    print "</table>
    \n";
  }

  &msg("Selected $rowcount STARS email address(es)");

  if ($email_addresses eq "")
  {
    &msg("<font color=red><b>ERROR:</b> No EMail addresses found in STARS for Host/Domain/Instance $this_hostname/$this_domain/$this_title1 - either this instance in not is STARS or DB error occured</font>");
    &msg("<font color=red>  This is caused by:</font>"); 
    &msg("<font color=red>    - STARS DB Error</font>");
    &msg("<font color=red>    - This instance was not configured in STARS</font>");
    &msg("<font color=red>    - This instance is <b>Monitor: N</b> and it has an SG alias </font>");
  }
}


#-----------------------------------------------------------------------------
sub getInstance
#-----------------------------------------------------------------------------
{
  ##&msg("Selecting DBC data for mode=$mode inst=$inst");

  # Count tasks
  $statement  = "
    select 
      text
    from 
      dbamon.dbcactive
    where
      dbamonmode = '${mode}'
      and i_hosts = '$inst'
      and text not like '#%'";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    ##print "$Data[0] \n";
    #$text = $Data[0];
    $_ = $Data[0];
    @words = split;
    chop($parm  = $words[0]);
    $value = $words[1];
    ##print "parm=$parm value=$value \n";
    if ($parm eq "OraApps_FS_Check") 
    {
      $cmd = "\$${parm} .= \"$value \"";
    }
    else
    {
      $cmd = "\$${parm} = \"$value\"";
    }
    ##print "cmd=$cmd \n";
    eval("$cmd"); 
  }

  if ($Host eq "")
  {
    &msg("<b>Error: I could not read the host definition for this instance</b>");
    &msg("<b>       from the DBAmon Oracle repository.</b>");
    &msg("<b>       DBAmon must be initializing.</b>");
    exit 1;
  }

  # Defaults
  $DBMS = "Informix" if $DBMS eq "";

  # Ensure that we have the right instance
  #$str = "${Host}${DBMS}${Title1}${ORACLE_SID}";
  chop($ck = `echo "$str" | cksum | awk '{ print \$1 }'`);
 
  &msg("Host=$Host Title1=$Title1 DBMS=$DBMS str=$str ck=$ck");

  if ($ckin ne $ck)   
  {
    system("echo ' ' | mailx -m -s 'dbamon_www_check.pl CKERR ($zcli) $inst $Title1 $DBMS ck=$ck ckin=$ckin [AUTO]' border\@dba.it.thecompany.com");
    &msg("<font color=red>The information for this instance does not verify correctly with the WWW instance that you selected.</font>");
    &msg("<font color=red>This probably means that an instance was added or removed recently, and the corresponding DBAmon</font> ");
    &msg("<font color=red>has not finished its current interaion. Please retry later.</font>");
    exit 1;
  }

  # Get the domain for this host
  chop($fqhostname = `nslookup $Host | grep Name: | awk '{ print \$2 }'`);
  ##print "fqhostname=$fqhostname\n";

  @words = split(/\./,$fqhostname);
  #$this_host = $words[0];

  $z = index($fqhostname,'.');
  $this_domain = substr($fqhostname,$z+1);
  ##print "z=$z this_domain=$this_domain\n";
}


#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
  }
  
  chop($os = `grep ORACLE_SID:  $rcfile | awk '{ print \$2}'`);
  chop($oh = `grep ORACLE_HOME: $rcfile | awk '{ print \$2}'`);

  ##&msg("Setting Oracle Env.");
  $ENV{"ORACLE_SID"} = $os;
  $ENV{"ORACLE_HOME"} = $oh;
  ##system("env | grep ORACLE");

  chop($hostname = `hostname`);
  chop($date = `date`);
  chop($wsname = `hostname`);
  #chop($wsnamef = `nslookup $wsname | grep Name: | awk '{ print \$2 }'`);

}
#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting this_hostname=$this_hostname this_domain=$this_domain arg3=$arg3 arg4=$arg4 hostname=$hostname");

&init;

&connectDBSTAR;
&getSTAR;

##system("echo ' ' | mailx -m -s '$P ($zcli) $Host $email_addresses [AUTO]' border\@dba.it.thecompany.com");

if ($email_addresses ne "")
{
  print " <ul><li><a href='mailto:$email_addresses'><b>Click Here To Send Outlook EMail To The Above $rowcount Addresses</b></a>
</ul>
";
}

&msg("Done");
system("rm $tmpfile > /dev/null 2>&1");
exit 0;
